CREATE OR REPLACE view "cash_collection" as  SELECT x0.depot,     x1.descr AS name,     x2.account_type,     (0.00 - sum(x0.amount)) AS amount    FROM sledger x0,     depot x1,     cust x2,     dparams x3   WHERE ((((((x0.typ = 13) AND (x0.cod IS NOT NULL)) AND (x0.period = x3.period)) AND (x0.depot = x2.depot)) AND (x0.cod = x2.cod)) AND (x0.depot = x1.cod))   GROUP BY x0.depot, x1.descr, x2.account_type;
CREATE OR REPLACE view "pvdetails" as  SELECT x0.trans_ser,     x0.vcode,     sum(x0.goods) AS goods,     sum(x0.vat) AS vat    FROM pdetails x0   GROUP BY x0.trans_ser, x0.vcode;
CREATE OR REPLACE view "sequence_setvals" as  SELECT (((((('SELECT setval(''"'::text || (cs.relname)::text) || '"'', max("'::text) || (a.attname)::text) || '")) FROM  "'::text) || (c.relname)::text) || '";'::text) AS expr    FROM pg_class c,     pg_class cs,     pg_attribute a,     pg_attrdef d   WHERE (((((cs.relkind = 'S'::"char") AND (d.adsrc ~ (''''::text || (cs.relname)::text))) AND (c.oid = a.attrelid)) AND (c.oid = d.adrelid)) AND (d.adnum = a.attnum));
CREATE OR REPLACE view "sequence_setvals1" as  SELECT (((((('      SELECT setval(''"'::text || (cs.relname)::text) || '"'',          max("'::text) || (a.attname)::text) || '")) FROM "'::text) || (c.relname)::text) || '";'::text) AS expr    FROM pg_class c,     pg_class cs,     pg_attribute a,     pg_attrdef d   WHERE (((((cs.relkind = 'S'::"char") AND (d.adsrc ~ (cs.relname)::text)) AND (c.oid = a.attrelid)) AND (c.oid = d.adrelid)) AND (d.adnum = a.attnum));
CREATE OR REPLACE view "v_active_contract" as  SELECT h.location,     h.contract    FROM (chead h      JOIN chdetail r ON (((h.location = r.location) AND (h.contract = r.contract))));
CREATE OR REPLACE view "v_cash" as  SELECT x0.cash_nominal AS nominal,     x0.typ,     x0.dat,     x0.tim,     x0.description AS descr,     x0.amount,     x0.contract,     x0.cash_invoice AS invoice,     x0.depot,     x0.cod AS cust,     x1.nam AS custname,     x0.ser,     x0.lodgement    FROM sledger x0,     cust x1   WHERE (((x0.depot = x1.depot) AND (x0.cod = x1.cod)) AND ((((((x0.typ = 3) OR (x0.typ = 18)) OR (x0.typ = 7)) OR (x0.typ = 11)) OR (x0.typ = 13)) OR (x0.typ = 17)));
CREATE OR REPLACE view "v_consumable_only" as  SELECT h.contract,     h.location,     h.cust,     h.depot,     h.site,     h.order_no,     h.dat,     h.tim,     h.deposit,     h.tender,     h.manual_ref,     h.policy,     h.calendar,     h.operator,     h.invoiced_to,     h.note,     h.hire_disc,     h.sales_disc,     h.quotation    FROM (chead h      JOIN codetail c ON (((h.location = c.location) AND (h.contract = c.contract))))   WHERE (NOT ((h.location, h.contract) IN ( SELECT chdetail.location,             chdetail.contract            FROM chdetail)));
CREATE OR REPLACE view "v_cur_nltb" as  SELECT x1.cod,     sum(x0.cur_bal) AS amount,     x0.period    FROM nlbals x0,     nominal x1,     nparams x2   WHERE ((x0.cod = x1.cod) AND (x1.leafs = 0))   GROUP BY x1.cod, x0.period;
CREATE OR REPLACE view "v_cur_turnover" as  SELECT x0.depot,     x0.cod,     sum(x0.amount) AS cur_total    FROM turnover x0,     dparams x1   WHERE ((x0.typ <> 4) AND (x0.period = x1.period))   GROUP BY x0.depot, x0.cod;
CREATE OR REPLACE view "v_cust_p_danal" as  SELECT ih.location,     ih.ac_location,     ih.cust,     ixd.pdesc AS plantorprod,     ih.period,     sum(         CASE ih.doc_type             WHEN 'CR'::bpchar THEN (ixd.goods * ((-1))::numeric)             ELSE ixd.goods         END) AS amount,     sum(         CASE ih.doc_type             WHEN 'CR'::bpchar THEN (ixd.qty * (-1))             ELSE ixd.qty         END) AS qty    FROM ihead ih,     iddetail ixd   WHERE ((((ih.doc_type = ixd.doc_type) AND (ih.location = ixd.location)) AND (ih.ref = ixd.ref)) AND (ih.cust = ixd.cust))   GROUP BY ih.location, ih.ac_location, ih.cust, ixd.pdesc, ih.period;
CREATE OR REPLACE view "v_cust_p_danal_salesrep" as  SELECT ih.location,     ih.ac_location,     ih.cust,     ixd.pdesc AS plantorprod,     ih.period,     cext.sales_rep,     sum(         CASE ih.doc_type             WHEN 'CR'::bpchar THEN (ixd.goods * ((-1))::numeric)             ELSE ixd.goods         END) AS amount,     sum(         CASE ih.doc_type             WHEN 'CR'::bpchar THEN (ixd.qty * (-1))             ELSE ixd.qty         END) AS qty    FROM ihead ih,     iddetail ixd,     cust_ext cext   WHERE ((((((ih.doc_type = ixd.doc_type) AND (ih.location = ixd.location)) AND (ih.ref = ixd.ref)) AND (ih.cust = ixd.cust)) AND (cext.depot = ih.ac_location)) AND (cext.cod = ih.cust))   GROUP BY ih.location, ih.ac_location, ih.cust, ixd.pdesc, ih.period, cext.sales_rep;
CREATE OR REPLACE view "v_cust_p_hanal" as  SELECT ih.location,     ih.ac_location,     ih.cust,     ixd.plant_desc AS plantorprod,     ih.period,     sum(         CASE ih.doc_type             WHEN 'CR'::bpchar THEN (ixd.goods * ((-1))::numeric)             ELSE ixd.goods         END) AS amount,     0 AS qty    FROM ihead ih,     ihdetail ixd   WHERE ((((ih.doc_type = ixd.doc_type) AND (ih.location = ixd.location)) AND (ih.ref = ixd.ref)) AND (ih.cust = ixd.cust))   GROUP BY ih.location, ih.ac_location, ih.cust, ixd.plant_desc, ih.period;
CREATE OR REPLACE view "v_cust_p_hanal_no_x" as  SELECT ih.location,     ih.ac_location,     ih.cust,     ixd.plant_desc AS plantorprod,     ih.period,     sum(         CASE ih.doc_type             WHEN 'CR'::bpchar THEN (ixd.goods * ((-1))::numeric)             ELSE ixd.goods         END) AS amount,     0 AS qty    FROM ihead ih,     ihdetail ixd   WHERE (((((ih.doc_type = ixd.doc_type) AND (ih.location = ixd.location)) AND (ih.ref = ixd.ref)) AND (ih.cust = ixd.cust)) AND ((ixd.plant_ref <> '9'::bpchar) OR (ixd.plant_ref IS NULL)))   GROUP BY ih.location, ih.ac_location, ih.cust, ixd.plant_desc, ih.period;
CREATE OR REPLACE view "v_cust_p_hanal_no_x_salesrep" as  SELECT ih.location,     ih.ac_location,     ih.cust,     ixd.plant_desc AS plantorprod,     ih.period,     cext.sales_rep,     sum(         CASE ih.doc_type             WHEN 'CR'::bpchar THEN (ixd.goods * ((-1))::numeric)             ELSE ixd.goods         END) AS amount,     0 AS qty    FROM ihead ih,     ihdetail ixd,     cust_ext cext   WHERE (((((((ih.doc_type = ixd.doc_type) AND (ih.location = ixd.location)) AND (ih.ref = ixd.ref)) AND (ih.cust = ixd.cust)) AND ((ixd.plant_ref <> '9'::bpchar) OR (ixd.plant_ref IS NULL))) AND (cext.depot = ih.ac_location)) AND (cext.cod = ih.cust))   GROUP BY ih.location, ih.ac_location, ih.cust, ixd.plant_desc, ih.period, cext.sales_rep;
CREATE OR REPLACE view "v_cust_p_hanal_salesrep" as  SELECT ih.location,     ih.ac_location,     ih.cust,     ixd.plant_desc AS plantorprod,     ih.period,     cext.sales_rep,     sum(         CASE ih.doc_type             WHEN 'CR'::bpchar THEN (ixd.goods * ((-1))::numeric)             ELSE ixd.goods         END) AS amount,     0 AS qty    FROM ihead ih,     ihdetail ixd,     cust_ext cext   WHERE ((((((ih.doc_type = ixd.doc_type) AND (ih.location = ixd.location)) AND (ih.ref = ixd.ref)) AND (ih.cust = ixd.cust)) AND (cext.depot = ih.ac_location)) AND (cext.cod = ih.cust))   GROUP BY ih.location, ih.ac_location, ih.cust, ixd.plant_desc, ih.period, cext.sales_rep;
CREATE OR REPLACE view "v_cust_p_sanal" as  SELECT ih.location,     ih.ac_location,     ih.cust,     ixd.product AS plantorprod,     ih.period,     sum(         CASE ih.doc_type             WHEN 'CR'::bpchar THEN (ixd.goods * ((-1))::numeric)             ELSE ixd.goods         END) AS amount,     sum(         CASE ih.doc_type             WHEN 'CR'::bpchar THEN (ixd.qty * ((-1))::numeric)             ELSE ixd.qty         END) AS qty    FROM ihead ih,     iodetail ixd   WHERE ((((ih.doc_type = ixd.doc_type) AND (ih.location = ixd.location)) AND (ih.ref = ixd.ref)) AND (ih.cust = ixd.cust))   GROUP BY ih.location, ih.ac_location, ih.cust, ixd.product, ih.period;
CREATE OR REPLACE view "v_cust_p_sanal_salesrep" as  SELECT ih.location,     ih.ac_location,     ih.cust,     ixd.product AS plantorprod,     ih.period,     cext.sales_rep,     sum(         CASE ih.doc_type             WHEN 'CR'::bpchar THEN (ixd.goods * ((-1))::numeric)             ELSE ixd.goods         END) AS amount,     sum(         CASE ih.doc_type             WHEN 'CR'::bpchar THEN (ixd.qty * ((-1))::numeric)             ELSE ixd.qty         END) AS qty    FROM ihead ih,     iodetail ixd,     cust_ext cext   WHERE ((((((ih.doc_type = ixd.doc_type) AND (ih.location = ixd.location)) AND (ih.ref = ixd.ref)) AND (ih.cust = ixd.cust)) AND (cext.depot = ih.ac_location)) AND (cext.cod = ih.cust))   GROUP BY ih.location, ih.ac_location, ih.cust, ixd.product, ih.period, cext.sales_rep;
CREATE OR REPLACE view "v_cust_p_sanalc" as  SELECT x0.ac_location,     x0.cust,     x1.product AS plantorprod,     x0.period,     sum(         CASE             WHEN (x0.doc_type = 'CR'::bpchar) THEN (x1.goods * (- (1)::numeric))             ELSE x1.goods         END) AS amount,     sum(x1.cost) AS cost,     sum(         CASE             WHEN (x0.doc_type = 'CR'::bpchar) THEN (x1.qty * (- (1)::numeric))             ELSE x1.qty         END) AS qty    FROM ihead x0,     iodetail x1   WHERE ((((x0.doc_type = x1.doc_type) AND (x0.location = x1.location)) AND (x0.ref = x1.ref)) AND (x0.cust = x1.cust))   GROUP BY x0.ac_location, x0.cust, x1.product, x0.period;
CREATE OR REPLACE view "v_cust_p_xanal" as  SELECT ih.location,     ih.ac_location,     ih.cust,     ixd.plant_desc AS plantorprod,     ih.period,     sum(         CASE ih.doc_type             WHEN 'CR'::bpchar THEN (ixd.goods * ((-1))::numeric)             ELSE ixd.goods         END) AS amount,     0 AS qty    FROM ihead ih,     ihdetail ixd   WHERE (((((ih.doc_type = ixd.doc_type) AND (ih.location = ixd.location)) AND (ih.ref = ixd.ref)) AND (ih.cust = ixd.cust)) AND (ixd.plant_ref = '9'::bpchar))   GROUP BY ih.location, ih.ac_location, ih.cust, ixd.plant_desc, ih.period;
CREATE OR REPLACE view "v_cust_p_xanal_salesrep" as  SELECT ih.location,     ih.ac_location,     ih.cust,     ixd.plant_desc AS plantorprod,     ih.period,     cext.sales_rep,     sum(         CASE ih.doc_type             WHEN 'CR'::bpchar THEN (ixd.goods * ((-1))::numeric)             ELSE ixd.goods         END) AS amount,     0 AS qty    FROM ihead ih,     ihdetail ixd,     cust_ext cext   WHERE (((((((ih.doc_type = ixd.doc_type) AND (ih.location = ixd.location)) AND (ih.ref = ixd.ref)) AND (ih.cust = ixd.cust)) AND (ixd.plant_ref = '9'::bpchar)) AND (cext.depot = ih.ac_location)) AND (cext.cod = ih.cust))   GROUP BY ih.location, ih.ac_location, ih.cust, ixd.plant_desc, ih.period, cext.sales_rep;
CREATE OR REPLACE view "v_cust_total" as  SELECT v_cust_p_hanal.ac_location,     v_cust_p_hanal.cust,     v_cust_p_hanal.period,     sum(v_cust_p_hanal.amount) AS amount    FROM v_cust_p_hanal   GROUP BY v_cust_p_hanal.ac_location, v_cust_p_hanal.cust, v_cust_p_hanal.period UNION ALL  SELECT v_cust_p_sanal.ac_location,     v_cust_p_sanal.cust,     v_cust_p_sanal.period,     sum(v_cust_p_sanal.amount) AS amount    FROM v_cust_p_sanal   GROUP BY v_cust_p_sanal.ac_location, v_cust_p_sanal.cust, v_cust_p_sanal.period UNION ALL  SELECT v_cust_p_danal.ac_location,     v_cust_p_danal.cust,     v_cust_p_danal.period,     sum(v_cust_p_danal.amount) AS amount    FROM v_cust_p_danal   GROUP BY v_cust_p_danal.ac_location, v_cust_p_danal.cust, v_cust_p_danal.period;
CREATE OR REPLACE view "v_cust_turnover" as  SELECT v_cust_total.ac_location,     v_cust_total.cust,     v_cust_total.period,     sum(v_cust_total.amount) AS amount    FROM v_cust_total   GROUP BY v_cust_total.ac_location, v_cust_total.cust, v_cust_total.period;
CREATE OR REPLACE view "v_custage" as  SELECT sledger.depot,     sledger.cod,     sledger.ser,     sledger.typ,     sledger.dat,     sledger.amount,     sledger.os,     sledger.period    FROM sledger   WHERE ((sledger.typ = 13) OR ((sledger.typ <> 13) AND (sledger.os <> (0)::numeric)));
CREATE OR REPLACE view "v_danal" as  SELECT x0.period,     x0.pdesc,     1 AS location,     x0.cust,     sum(x0.cm_qty) AS cm_qty,     sum(x0.cm_sales) AS cm_sales,     sum(x0.cm_cost) AS cm_cost,     sum(x0.ytd_qty) AS ytd_qty,     sum(x0.ytd_sales) AS ytd_sales,     sum(x0.ytd_cost) AS ytd_cost    FROM danal x0   GROUP BY x0.period, x0.pdesc, x0.cust;
CREATE OR REPLACE view "v_depot_stock" as  SELECT x0.pdesc,     x0.location,     sum(x0.qty) AS tot    FROM pstock x0   GROUP BY x0.pdesc, x0.location;
CREATE OR REPLACE view "v_mcost" as  SELECT x0.pdesc,     sum(((x0.unit_cost - x0.unit_depn) * (x0.qty)::numeric)) AS value    FROM pcost x0   GROUP BY x0.pdesc;
CREATE OR REPLACE view "v_plant_stock" as  SELECT x0.pdesc,     sum(x0.qty) AS tot    FROM pstock x0   GROUP BY x0.pdesc;
CREATE OR REPLACE view "v_dep_val" as  SELECT x2.pdesc,     x2.location,     sum(((x0.value / (x1.tot)::numeric) * (x2.tot)::numeric)) AS value    FROM v_mcost x0,     v_plant_stock x1,     v_depot_stock x2   WHERE ((((x0.pdesc = x1.pdesc) AND (x0.pdesc = x2.pdesc)) AND (x1.pdesc = x2.pdesc)) AND ((x1.tot)::numeric <> (0)::numeric))   GROUP BY x2.pdesc, x2.location;
CREATE OR REPLACE view "v_hanal" as  SELECT x0.period,     x0.cod,     1 AS location,     x0.cust,     sum(x0.cm_sales) AS cm_sales,     sum(x0.cm_cost) AS cm_cost,     sum(x0.ytd_sales) AS ytd_sales,     sum(x0.ytd_cost) AS ytd_cost,     'N'::bpchar AS cross_hire    FROM hanal x0   GROUP BY x0.period, x0.cod, x0.cust;
CREATE OR REPLACE view "v_ixdetails" as  SELECT x0.doc_type,     x0.location,     x0.ac_location,     x0.cust,     x0.ref AS invoice_ref,     'Disposal'::text AS line_type,     x0.line_number,     x3.descr AS dept,     x4.descr AS dept_group,     x0.pdesc AS item_code,     x1.desc1 AS description,     x0.qty,     '1899-12-31'::date AS date_out,     '1899-12-31'::date AS date_in,     (0)::numeric AS time_charged,     ''::text AS charge_period,     x0.unit_sell,     x0.goods,     x0.vcode,     x0.vrate,     x0.vat    FROM iddetail x0,     pdesc x1,     pdesc_ext x2,     hire_dept x3,     hire_dept_group x4   WHERE ((((((x0.doc_type <> 'CR'::bpchar) AND (x0.pdesc = x1.cod)) AND (x0.reg IS NULL)) AND (x1.cod = x2.pdesc)) AND (x2.dept_group = x4.nsuk)) AND (x4.hire_dept = x3.nsuk)) UNION  SELECT x5.doc_type,     x5.location,     x5.ac_location,     x5.cust,     x5.ref AS invoice_ref,     'Disposal'::text AS line_type,     x5.line_number,     x8.descr AS dept,     x9.descr AS dept_group,     ((x5.pdesc)::text || (x5.reg)::text) AS item_code,     x6.desc1 AS description,     x5.qty,     '1899-12-31'::date AS date_out,     '1899-12-31'::date AS date_in,     (0)::numeric AS time_charged,     ''::text AS charge_period,     x5.unit_sell,     x5.goods,     x5.vcode,     x5.vrate,     x5.vat    FROM iddetail x5,     pdesc x6,     pdesc_ext x7,     hire_dept x8,     hire_dept_group x9   WHERE ((((((x5.doc_type <> 'CR'::bpchar) AND (x5.pdesc = x6.cod)) AND (x5.reg IS NOT NULL)) AND (x6.cod = x7.pdesc)) AND (x7.dept_group = x9.nsuk)) AND (x9.hire_dept = x8.nsuk)) UNION  SELECT x10.doc_type,     x10.location,     x10.ac_location,     x10.cust,     x10.ref AS invoice_ref,     'Disposal'::text AS line_type,     x10.line_number,     x13.descr AS dept,     x14.descr AS dept_group,     x10.pdesc AS item_code,     x11.desc1 AS description,     x10.qty,     '1899-12-31'::date AS date_out,     '1899-12-31'::date AS date_in,     (0)::numeric AS time_charged,     ''::text AS charge_period,     ((0)::numeric - x10.unit_sell) AS unit_sell,     ((0)::numeric - x10.goods) AS goods,     x10.vcode,     x10.vrate,     ((0)::numeric - x10.vat) AS vat    FROM iddetail x10,     pdesc x11,     pdesc_ext x12,     hire_dept x13,     hire_dept_group x14   WHERE ((((((x10.doc_type = 'CR'::bpchar) AND (x10.pdesc = x11.cod)) AND (x10.reg IS NULL)) AND (x11.cod = x12.pdesc)) AND (x12.dept_group = x14.nsuk)) AND (x14.hire_dept = x13.nsuk)) UNION  SELECT x15.doc_type,     x15.location,     x15.ac_location,     x15.cust,     x15.ref AS invoice_ref,     'Disposal'::text AS line_type,     x15.line_number,     x18.descr AS dept,     x19.descr AS dept_group,     ((x15.pdesc)::text || (x15.reg)::text) AS item_code,     x16.desc1 AS description,     x15.qty,     '1899-12-31'::date AS date_out,     '1899-12-31'::date AS date_in,     (0)::numeric AS time_charged,     ''::text AS charge_period,     ((0)::numeric - x15.unit_sell) AS unit_sell,     ((0)::numeric - x15.goods) AS goods,     x15.vcode,     x15.vrate,     ((0)::numeric - x15.vat) AS vat    FROM iddetail x15,     pdesc x16,     pdesc_ext x17,     hire_dept x18,     hire_dept_group x19   WHERE ((((((x15.doc_type = 'CR'::bpchar) AND (x15.pdesc = x16.cod)) AND (x15.reg IS NOT NULL)) AND (x16.cod = x17.pdesc)) AND (x17.dept_group = x19.nsuk)) AND (x19.hire_dept = x18.nsuk)) UNION  SELECT x20.doc_type,     x20.location,     x20.ac_location,     x20.cust,     x20.ref AS invoice_ref,     'Sale'::text AS line_type,     x20.line_number,     x23.descr AS dept,     x24.descr AS dept_group,     x21.plu AS item_code,     x21.descr AS description,     x20.qty,     '1899-12-31'::date AS date_out,     '1899-12-31'::date AS date_in,     (0)::numeric AS time_charged,     ''::text AS charge_period,     x20.price AS unit_sell,     x20.goods,     x20.vcode,     x20.vrate,     x20.vat    FROM iodetail x20,     product_type x21,     product x22,     dept x23,     dept_group x24   WHERE (((((x20.doc_type <> 'CR'::bpchar) AND (x20.product_type = x21.nsuk)) AND (x21.product = x22.nsuk)) AND (x22.dept_group = x24.nsuk)) AND (x24.dept = x23.nsuk)) UNION  SELECT x25.doc_type,     x25.location,     x25.ac_location,     x25.cust,     x25.ref AS invoice_ref,     'Sale'::text AS line_type,     x25.line_number,     x28.descr AS dept,     x29.descr AS dept_group,     x26.plu AS item_code,     x26.descr AS description,     x25.qty,     '1899-12-31'::date AS date_out,     '1899-12-31'::date AS date_in,     (0)::numeric AS time_charged,     ''::text AS charge_period,     ((0)::numeric - x25.price) AS unit_sell,     ((0)::numeric - x25.goods) AS goods,     x25.vcode,     x25.vrate,     ((0)::numeric - x25.vat) AS vat    FROM iodetail x25,     product_type x26,     product x27,     dept x28,     dept_group x29   WHERE (((((x25.doc_type = 'CR'::bpchar) AND (x25.product_type = x26.nsuk)) AND (x26.product = x27.nsuk)) AND (x27.dept_group = x29.nsuk)) AND (x29.dept = x28.nsuk)) UNION  SELECT x30.doc_type,     x30.location,     x30.ac_location,     x30.cust,     x30.ref AS invoice_ref,     'Rental'::text AS line_type,     x30.line_number,     x33.descr AS dept,     x34.descr AS dept_group,     ((x30.plant_desc)::text || (x30.plant_ref)::text) AS item_code,     x31.desc1 AS description,     x30.qty,     x30.date_out,     x30.date_in,     x30.time_charged,     x30.charge_period,     x30.rate AS unit_sell,     x30.goods,     x30.vcode,     x30.vrate,     x30.vat    FROM ihdetail x30,     pdesc x31,     pdesc_ext x32,     hire_dept x33,     hire_dept_group x34   WHERE ((((((x30.doc_type <> 'CR'::bpchar) AND (x30.plant_desc = x31.cod)) AND (x30.plant_ref IS NOT NULL)) AND (x31.cod = x32.pdesc)) AND (x32.dept_group = x34.nsuk)) AND (x34.hire_dept = x33.nsuk)) UNION  SELECT x35.doc_type,     x35.location,     x35.ac_location,     x35.cust,     x35.ref AS invoice_ref,     'Rental'::text AS line_type,     x35.line_number,     x38.descr AS dept,     x39.descr AS dept_group,     x35.plant_desc AS item_code,     x36.desc1 AS description,     x35.qty,     x35.date_out,     x35.date_in,     x35.time_charged,     x35.charge_period,     x35.rate AS unit_sell,     x35.goods,     x35.vcode,     x35.vrate,     x35.vat    FROM ihdetail x35,     pdesc x36,     pdesc_ext x37,     hire_dept x38,     hire_dept_group x39   WHERE ((((((x35.doc_type <> 'CR'::bpchar) AND (x35.plant_desc = x36.cod)) AND (x35.plant_ref IS NULL)) AND (x36.cod = x37.pdesc)) AND (x37.dept_group = x39.nsuk)) AND (x39.hire_dept = x38.nsuk)) UNION  SELECT x40.doc_type,     x40.location,     x40.ac_location,     x40.cust,     x40.ref AS invoice_ref,     'Rental'::text AS line_type,     x40.line_number,     x43.descr AS dept,     x44.descr AS dept_group,     ((x40.plant_desc)::text || (x40.plant_ref)::text) AS item_code,     x41.desc1 AS description,     x40.qty,     x40.date_out,     x40.date_in,     x40.time_charged,     x40.charge_period,     ((0)::numeric - x40.rate) AS unit_sell,     ((0)::numeric - x40.goods) AS goods,     x40.vcode,     x40.vrate,     ((0)::numeric - x40.vat) AS vat    FROM ihdetail x40,     pdesc x41,     pdesc_ext x42,     hire_dept x43,     hire_dept_group x44   WHERE ((((((x40.doc_type = 'CR'::bpchar) AND (x40.plant_desc = x41.cod)) AND (x40.plant_ref IS NOT NULL)) AND (x41.cod = x42.pdesc)) AND (x42.dept_group = x44.nsuk)) AND (x44.hire_dept = x43.nsuk)) UNION  SELECT x45.doc_type,     x45.location,     x45.ac_location,     x45.cust,     x45.ref AS invoice_ref,     'Rental'::text AS line_type,     x45.line_number,     x48.descr AS dept,     x49.descr AS dept_group,     x45.plant_desc AS item_code,     x46.desc1 AS description,     x45.qty,     x45.date_out,     x45.date_in,     x45.time_charged,     x45.charge_period,     ((0)::numeric - x45.rate) AS unit_sell,     ((0)::numeric - x45.goods) AS goods,     x45.vcode,     x45.vrate,     ((0)::numeric - x45.vat) AS vat    FROM ihdetail x45,     pdesc x46,     pdesc_ext x47,     hire_dept x48,     hire_dept_group x49   WHERE ((((((x45.doc_type = 'CR'::bpchar) AND (x45.plant_desc = x46.cod)) AND (x45.plant_ref IS NULL)) AND (x46.cod = x47.pdesc)) AND (x47.dept_group = x49.nsuk)) AND (x49.hire_dept = x48.nsuk));
CREATE OR REPLACE view "v_jlproof" as  SELECT x2.source,     x2.batch,     x0.nominal_period AS period,     x0.dat,     x0.note AS jrnl_note,     x1.ledger,     x1.depot,     x1.cod,     x2.description,     x2.cc,     x2.amount,     x2.notes AS note    FROM journals x0,     jdetails x1,     nltrans x2   WHERE ((x0.ser = x1.journal_no) AND (x1.nl_trans = x2.trans_no));
CREATE OR REPLACE view "v_pdetails" as  SELECT x0.trans_ser,     x0.nominal,     x0.goods,     x0.vcode,     x0.vat,     x0.ser    FROM pdetails x0,     pledger x1   WHERE ((x0.trans_ser = x1.ser) AND (x1.typ > 10)) UNION  SELECT x2.trans_ser,     x2.nominal,     (x2.goods * (-1.00)) AS goods,     x2.vcode,     (x2.vat * (-1.00)) AS vat,     x2.ser    FROM pdetails x2,     pledger x3   WHERE ((x2.trans_ser = x3.ser) AND (x3.typ < 10));
CREATE OR REPLACE view "v_pt_bin_location" as  SELECT x0.product_type,     x1.location,     x1.nsuk AS bin_location    FROM (pt_bin_loc x0      JOIN bin_location x1 ON ((x0.bin_location = x1.nsuk)));
CREATE OR REPLACE view "v_returns" as  SELECT x0.contract_location AS location,     x0.contract,     x0.pdesc,     x0.reg,     x1.dat AS date_returned,     x0.qty AS qty_returned    FROM hmdetail x0,     hmhead x1   WHERE (((x0.doc_type = x1.doc_type) AND (x0.doc_number = x1.doc_number)) AND (x0.doc_type = 2));
CREATE OR REPLACE view "v_revenue_ltd" as  SELECT 'H'::text AS asset_reg,     r.plant_desc,     r.plant_ref,     sum(         CASE             WHEN (r.doc_type = 'CR'::bpchar) THEN ((0)::numeric - r.goods)             ELSE r.goods         END) AS revenue,     sum(         CASE             WHEN (r.doc_type = 'CR'::bpchar) THEN (0 - r.dayes)             ELSE r.dayes         END) AS dayes    FROM (ihead h      JOIN ihdetail r ON ((((h.doc_type = r.doc_type) AND (h.location = r.location)) AND (h.ref = r.ref))))   GROUP BY 'H'::text, r.plant_desc, r.plant_ref;
CREATE OR REPLACE view "v_revenue_mtd" as  SELECT 'H'::text AS asset_reg,     r.plant_desc,     r.plant_ref,     sum(         CASE             WHEN (r.doc_type = 'CR'::bpchar) THEN ((0)::numeric - r.goods)             ELSE r.goods         END) AS revenue,     sum(         CASE             WHEN (r.doc_type = 'CR'::bpchar) THEN (0 - r.dayes)             ELSE r.dayes         END) AS dayes    FROM (ihead h      JOIN ihdetail r ON ((((h.doc_type = r.doc_type) AND (h.location = r.location)) AND (h.ref = r.ref)))),     dparams d   WHERE (h.period = d.period)   GROUP BY 'H'::text, r.plant_desc, r.plant_ref;
CREATE OR REPLACE view "v_revenue_ytd" as  SELECT 'H'::text AS asset_reg,     r.plant_desc,     r.plant_ref,     sum(         CASE             WHEN (r.doc_type = 'CR'::bpchar) THEN ((0)::numeric - r.goods)             ELSE r.goods         END) AS revenue,     sum(         CASE             WHEN (r.doc_type = 'CR'::bpchar) THEN (0 - r.dayes)             ELSE r.dayes         END) AS dayes    FROM (ihead h      JOIN ihdetail r ON ((((h.doc_type = r.doc_type) AND (h.location = r.location)) AND (h.ref = r.ref)))),     (dparams d      JOIN period_map m ON ((m.period = d.period)))   WHERE ((h.period >= m.boy_period) AND (h.period <= d.period))   GROUP BY 'H'::text, r.plant_desc, r.plant_ref;
CREATE OR REPLACE view "v_sanal" as  SELECT x0.period,     x0.product,     1 AS location,     x0.cust,     sum(x0.cm_qty) AS cm_qty,     sum(x0.cm_sales) AS cm_sales,     sum(x0.cm_cost) AS cm_cost,     sum(x0.ytd_qty) AS ytd_qty,     sum(x0.ytd_sales) AS ytd_sales,     sum(x0.ytd_cost) AS ytd_cost    FROM sanal x0   GROUP BY x0.period, x0.product, x0.cust;
CREATE OR REPLACE view "v_service_ltd" as  SELECT w.asset_reg,     w.pdesc,     w.cod,     sum(w.cost) AS cost    FROM ws_job w,     dparams d   WHERE (w.status = 7)   GROUP BY w.asset_reg, w.pdesc, w.cod;
CREATE OR REPLACE view "v_service_mtd" as  SELECT w.asset_reg,     w.pdesc,     w.cod,     sum(w.cost) AS cost    FROM ws_job w,     dparams d   WHERE ((w.status = 7) AND (jp_period(w.completed_date) = d.period))   GROUP BY w.asset_reg, w.pdesc, w.cod;
CREATE OR REPLACE view "v_service_ytd" as  SELECT w.asset_reg,     w.pdesc,     w.cod,     sum(w.cost) AS cost    FROM ws_job w,     (dparams d      JOIN period_map m ON ((m.period = d.period)))   WHERE ((w.status = 7) AND ((jp_period(w.completed_date) >= m.boy_period) AND (jp_period(w.completed_date) <= d.period)))   GROUP BY w.asset_reg, w.pdesc, w.cod;
CREATE OR REPLACE view "v_supplier_p_sanalc" as  SELECT x0.ac_location,     p2.supplier,     p3.supplier_ref AS plantorprod,     x1.product_type,     x0.period,         CASE             WHEN (x0.doc_type = 'CR'::bpchar) THEN (x1.goods * (- (1)::numeric))             ELSE x1.goods         END AS amount,         CASE             WHEN (x0.doc_type = 'CR'::bpchar) THEN ((x1.cost * x1.qty) * (- (1)::numeric))             ELSE (x1.cost * x1.qty)         END AS cost,         CASE             WHEN (x0.doc_type = 'CR'::bpchar) THEN (x1.qty * (- (1)::numeric))             ELSE x1.qty         END AS qty    FROM ihead x0,     iodetail x1,     product_type p1,     product p2,     pt_supplier p3   WHERE ((((((((x0.doc_type = x1.doc_type) AND (x0.location = x1.location)) AND (x0.ref = x1.ref)) AND (x0.cust = x1.cust)) AND (x1.product_type = p1.nsuk)) AND (p1.product = p2.nsuk)) AND (p3.product_type = p1.nsuk)) AND (p3.supplier = p2.supplier));
CREATE OR REPLACE view "v_turnover" as  SELECT pl.supplier,     supp.nam,     pl.period,     sum((pl.amount - pl.vat)) AS amount    FROM pledger pl,     supplier supp   WHERE (((pl.typ = 2) OR (pl.typ = 11)) AND (supp.cod = pl.supplier))   GROUP BY pl.supplier, supp.nam, pl.period;
CREATE OR REPLACE view "v_vatsum_raw" as  SELECT         CASE             WHEN (pd.vcode IS NULL) THEN 1             ELSE pd.vcode         END AS cod,     'P'::text AS ledger,     pl.typ AS trans,         CASE             WHEN (pd.goods IS NULL) THEN (pl.amount - pl.vat)             ELSE pd.goods         END AS goods,         CASE             WHEN (pd.vat IS NULL) THEN pl.vat             ELSE pd.vat         END AS vat,     pl.period    FROM (pledger pl      LEFT JOIN pdetails pd ON ((pl.ser = pd.trans_ser)))   WHERE (pl.typ = ANY (ARRAY[2, 11])) UNION ALL  SELECT ixd.vcode AS cod,     'S'::text AS ledger,     (         CASE ih.doc_type             WHEN 'CR'::bpchar THEN 12             ELSE 2         END)::smallint AS trans,     ixd.goods,     ixd.vat,     ih.period    FROM ihead ih,     ihdetail ixd   WHERE ((((ih.doc_type = ixd.doc_type) AND (ih.location = ixd.location)) AND (ih.ref = ixd.ref)) AND (ih.cust = ixd.cust)) UNION ALL  SELECT ixd.vcode AS cod,     'S'::text AS ledger,     (         CASE ih.doc_type             WHEN 'CR'::bpchar THEN 12             ELSE 2         END)::smallint AS trans,     ixd.goods,     ixd.vat,     ih.period    FROM ihead ih,     iodetail ixd   WHERE ((((ih.doc_type = ixd.doc_type) AND (ih.location = ixd.location)) AND (ih.ref = ixd.ref)) AND (ih.cust = ixd.cust)) UNION ALL  SELECT ixd.vcode AS cod,     'S'::text AS ledger,     (         CASE ih.doc_type             WHEN 'CR'::bpchar THEN 12             ELSE 2         END)::smallint AS trans,     ixd.goods,     ixd.vat,     ih.period    FROM ihead ih,     iddetail ixd   WHERE ((((ih.doc_type = ixd.doc_type) AND (ih.location = ixd.location)) AND (ih.ref = ixd.ref)) AND (ih.cust = ixd.cust)) UNION ALL  SELECT (1)::smallint AS cod,     'S'::text AS ledger,     sledger.typ AS trans,     ((sledger.amount - sledger.vat) * ((-1))::numeric) AS goods,     (sledger.vat * ((-1))::numeric) AS vat,     sledger.period    FROM sledger   WHERE ((sledger.typ = 16) AND (sledger.cod IS NOT NULL)) UNION ALL  SELECT (1)::smallint AS cod,     'S'::text AS ledger,     sledger.typ AS trans,     ((sledger.amount - sledger.vat) * ((-1))::numeric) AS goods,     (sledger.vat * ((-1))::numeric) AS vat,     sledger.period    FROM sledger   WHERE ((sledger.typ = 18) AND (sledger.cod IS NOT NULL));
CREATE OR REPLACE view "v_vatsum2" as  SELECT v.cod,     v.ledger,     v.trans,     sum(v.goods) AS goods,     sum(v.vat) AS vat,     v.period    FROM v_vatsum_raw v   WHERE (((v.ledger = 'P'::text) AND (v.trans > 10)) OR ((v.ledger = 'S'::text) AND (v.trans < 10)))   GROUP BY v.cod, v.ledger, v.trans, v.period UNION  SELECT v.cod,     v.ledger,     v.trans,     (sum(v.goods) * ((-1))::numeric) AS goods,     (sum(v.vat) * ((-1))::numeric) AS vat,     v.period    FROM v_vatsum_raw v   WHERE (((v.ledger = 'P'::text) AND (v.trans < 10)) OR ((v.ledger = 'S'::text) AND (v.trans > 10)))   GROUP BY v.cod, v.ledger, v.trans, v.period;
CREATE OR REPLACE view "v_ytd_nltb" as  SELECT x1.cod,     sum(x1.ytd_bal) AS amount,     x1.period    FROM nominal x0,     nlbals x1,     nparams x2   WHERE (((x1.cod = x0.cod) AND (x1.ytd_bal <> 0.00)) AND (x0.leafs = 0))   GROUP BY x1.cod, x1.period;
CREATE OR REPLACE view "v_ytd_turnover" as  SELECT x0.depot,     x0.cod,     sum(x0.amount) AS ytd_total    FROM turnover x0,     dparams x1   WHERE ((x0.period >= x1.boy_period) AND (x0.typ <> 4))   GROUP BY x0.depot, x0.cod;
